#TouhouDanmakufu[Stage]
#ScriptVersion[3]
#ID["Main"]
#Title["Aiiko Boss (No Dialogue)"]
#Text["Aiiko and Murloc play togheter with some danmaku (And doesn't talk at all for some reasons)."]
#Player["./System/Murloc/Reimu/Reimu.txt"]
#Image["./System/img/Starry Aiiko.png"]


#include "./System/ZUNShot_Const.txt"
#include"./Index.txt"
#include "./background.txt"
//#include "./script/system/lib/ReimuAnim.dnh"
#include "./System/dialogue.dnh"

let end = false;
let bgm = ObjSound_Create;
let bgm2 = ObjSound_Create;
let BGM = GetCurrentScriptDirectory() ~ "./SFX/Romantic Children.mp3";
let BGM2 = GetCurrentScriptDirectory() ~ "./SFX/Unknown X.mp3";
let PlayerShotSE = GetCurrentScriptDirectory() ~ "/SFX/select.wav";
	let objEnemy;

@Event{
}

@Initialize{
	Init;
	SetPlayerLife(10);
	LoadSound(PlayerShotSE);
	LoadSound(BGM);
	LoadSound(BGM2);
	TStage;

	objEnemy = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(objEnemy);
	renderBoss(1);
	//	MagicCircle;
	ObjMove_SetPosition(objEnemy, 190, -50);
	
	InstallFont(GetCurrentScriptDirectory() ~ "./System/AndaleMono.ttf");
	InstallFont(GetCurrentScriptDirectory() ~ "./System/Russell Square Regular.ttf");
	
	SetCommonData("Main", GetOwnScriptID());
	
	SetForbidPlayerShot(true);
	SetForbidPlayerSpell(true);

	ObjSound_Load(bgm, BGM);
	ObjSound_SetSoundDivision(BGM, SOUND_BGM);
	ObjSound_SetLoopEnable(bgm, true);
	ObjSound_SetLoopTime(bgm, 26.55,158.6);

	ObjSound_Load(bgm2, BGM2);
	ObjSound_SetSoundDivision(BGM2, SOUND_BGM);
	ObjSound_SetLoopEnable(bgm2, true);
	ObjSound_SetLoopTime(bgm2, 0, 77777);
}

@MainLoop{
	if(GetPlayerState() == STATE_END){
		FinalizeStage;
	}
	yield;
}

task TStage{
	let pluralmid = dir ~ "./Plural1.cs";
	let pluralboss1 = dir ~ "./Plural2.cs";
	let mid = LoadScriptInThread(pluralmid);
	let boss1 = LoadScriptInThread(pluralboss1);

	wait(60);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, 190, 160, 15,6);
	ObjSound_Play(bgm);
	wait(60);
	
	SetForbidPlayerShot(false);
	SetForbidPlayerSpell(false);
	PlaySE(Attack2);
	
	wait(30);
	StartScript(mid);
	Obj_Delete(objEnemy);
	
	while(!IsCloseScript(mid)){yield;}
	StopSound(BGM);
	//Obj_Delete(bgm);
	ObjSound_Play(bgm2);

	SetForbidPlayerShot(true);
	SetForbidPlayerSpell(true);

	let objText_ = ObjText_Create(); // Dialogue. (Part 2)
	let objImg1_ = ObjPrim_Create(OBJ_SPRITE_2D); // You also have to set up new variables for the second set.
	let objImg2_ = ObjPrim_Create(OBJ_SPRITE_2D);
	let objBox_ = ObjPrim_Create(OBJ_SPRITE_2D);
	objEnemy = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(objEnemy);
	renderBoss(1);
	//MagicCircle;
	ObjMove_SetPosition(objEnemy, 190, 60);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, 190, 160, 15,6);
	wait(60);
	
	SetForbidPlayerShot(false);
	SetForbidPlayerSpell(false);
	Obj_Delete(objText_);
	Obj_Delete(objImg1_);
	Obj_Delete(objImg2_);
	Obj_Delete(objBox_);

	wait(120);
	
	Obj_Delete(objEnemy);
	StartScript(boss1);

	while(!IsCloseScript(boss1)){yield;}

	SetForbidPlayerShot(true);
	SetForbidPlayerSpell(true);

	objEnemy = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(objEnemy);
	renderBoss(1);
	ObjMove_SetPosition(objEnemy, 190, 60);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, 190, 160, 15,6);
	wait(120);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, 190, 100, 15,6);
	wait(120);
	PlaySE(Twinkle3);
	ObjMove_SetDestAtWeight(objEnemy, GetStgFrameWidth+50, -100, 15,6);

	wait(120);

	// STGClearScore(1000000000);

	FinalizeStage;
}

task FinalizeStage{
	wait(180);
	StopSound(BGM2);
	if(GetScore > GetAreaCommonData("HighScore", "Score", 0)){ // Saves the high score.
		SetAreaCommonData("HighScore", "Score", GetScore);
		SaveCommonDataAreaA1("HighScore");
	}
	CloseStgScene();
}