#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_S7"]
	#Text["Impossible Danmaku [r]Blue & Orange [r] They Just came up with this on the spot"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
		let Toki;
		let TokiAngle = 0;
	let BGM = CSD ~ "./SFX/Toki_furro.mp3";
	
	@Initialize{
		SetAutoDeleteObject(true);
	
		let objScene = GetEnemyBossSceneObjectID();
		ObjEnemyBossScene_StartSpell(objScene);

		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetPosition(objEnemy, 100, GetClipMaxY/4);
		Toki = DrawAiiko(-100,100,false);
		ObjEnemy_SetDamageRate(objEnemy, 100, 50);
		movement;
		Fire;
		renderBoss(1);
		//TRenderBG(3,0,3000);
		TEnd;

		LoadSound(BGM);
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ObjMove_GetX(Toki), ObjMove_GetY(Toki), 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ObjMove_GetX(Toki), ObjMove_GetY(Toki), 24);
		DeleteShotInCircle(TYPE_SHOT,TYPE_FADE ,ObjMove_GetX(Toki),ObjMove_GetY(Toki),50);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(6000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(120);
		}
		case(EV_REQUEST_SPELL_SCORE) {
			SetScriptResult(200000);
		}
	}
	
	task movement{
		Cutin(objEnemy,"Impossible Danmaku [r]Blue & Orange",2);
		let B = 00;
		let C2 = 180;
		let C = C2/2;
		let X = 0;
		let Y = 0;
			X=GetClipMaxX/2+C*sin(B);
			Y=(GetClipMaxY/2)-C2*cos(B);
			B+=6;
			ObjMove_SetDestAtFrame(objEnemy,X,Y,180);
		wait(180);
		loop{
			X=GetClipMaxX/2+C*sin(B);
			Y=GetClipMaxY/2-C2*cos(B);
			B+=4;
			ObjMove_SetDestAtFrame(objEnemy,X,Y,6);
			wait(6);
		}
	}
	
	task Fire{
		wait(60);
		let ang =-45;
		let ang2 =225;
		AttackOn;
        FireRing;
		wait(80);
			loop(7){TChargeEffect(GetPlayerX,GetPlayerY,3);wait(6);}
			
			laser2(rand(0,180),1);
		loop{
			laser(ang,1);
			laser(ang2,2);
			ang+=36;
			ang2-=18;
			if(ang >= 315){ang = -45;}
			if(ang2<=-135){ang2= 225;}
			wait(42);
		}
	}
	
	task FireRing{
        wait(120);
		Cutin2(objEnemy,"Escudo de Proteccion [r]Divina");
		let obj;
		let angle= 0;
		let color= 186;
		while (angle<360){
		    obj = CreateShotA2(GetPlayerX+90*sin(angle),GetPlayerY-90*cos(angle),3,angle+40,-0.03,0.5,color,24);
			ObjShot_SetIntersectionEnable(obj, false);
		    angle+=360/35;
		    color++;
			ObjShot_SetAutoDelete(obj, false);
			ObjShot_SetSpellResist(obj,true);
		    if(color>=193){color= 186;}
            BulletMove(obj,40,1);
		}
        wait(6);
        angle= 0;
		while (angle<360){
		    obj = CreateShotA2(GetPlayerX+80*sin(angle),GetPlayerY-80*cos(angle),3,angle+50,-0.03,0.5,color,18);
			ObjShot_SetIntersectionEnable(obj, false);
		    angle+=360/21;
		    color++;
			ObjShot_SetAutoDelete(obj, false);
			ObjShot_SetSpellResist(obj,true);
		    if(color>=193){color= 186;}
            BulletMove(obj,50,1.2);
		}
        wait(6);
        angle= 0;
		while (angle<360){
		    obj = CreateShotA2(GetPlayerX+100*sin(angle),GetPlayerY-100*cos(angle),3,angle+60,-0.03,0.5,color,12);
			ObjShot_SetIntersectionEnable(obj, false);
		    angle+=360/7;
		    color++;
			ObjShot_SetAutoDelete(obj, false);
			ObjShot_SetSpellResist(obj,true);
		    if(color>=193){color= 186;}
            BulletMove(obj,60,1.4);
		}
	}

    task BulletMove(obj,C,A){
        wait(180);
        let angle = ObjMove_GetAngle(obj)-180;
        loop{
            ObjMove_SetDestAtFrame(obj,GetPlayerX+C*sin(angle),GetPlayerY-C*cos(angle),6);
			ObjPlayer_AddIntersectionCircleA1(objEnemy, ObjMove_GetX(obj), ObjMove_GetY(obj),1, 1);
            angle+=A;
            yield;
        }
    }

    task laser(ang,type){
        wait(160);
		let length = 0;
		let angle = ang;
		let angle2 = rand(0,30);
		let angle3 = 0;
		let anglecheck = 0;
		let anglecheck2 = 0;
		let ColorPointer;
		let Color1;
		let Color2;
			if(type==1){ColorPointer = 9; Color1 = 84; Color2 = 39;}
			if(type==2){ColorPointer = 7; Color1 = 86; Color2 = 41;}
        let pointer = CreateStraightLaserA1(ex+40*sin(angle),ey-30*cos(angle),angle,length,10,410,ColorPointer,0);
					ObjShot_SetIntersectionEnable(pointer, false);
        loop(360){
            ObjMove_SetX(pointer,ex+40*sin(angle+90));
            ObjMove_SetY(pointer,ey-30*cos(angle+90));
			anglecheck2 = GetAngleToPlayer(objEnemy);
			if(type==1){if(GetPlayerY<ey){anglecheck2 = GetAngleToPlayer(objEnemy) +360;}}
            	anglecheck = ObjStLaser_GetAngle(pointer)-anglecheck2;
            if (anglecheck < 0){anglecheck = anglecheck*-1;}
            if (anglecheck < 10){
                length = GetGapLength(ex,ey,GetPlayerX,GetPlayerY)-70;
				PlaySound(Twinkle3);
				while(angle3<360){
            	let obj = CreateShotA1(GetPlayerX+50*sin(angle3+angle2), GetPlayerY-50*cos(angle3+angle2), 3, angle3+angle2-90, Color1, 10);
            	let obj2 = CreateShotA1(GetPlayerX+50*sin(angle3+angle2), GetPlayerY-50*cos(angle3+angle2), 3, angle3+angle2-90, Color2, 6);
				if(type==1){
					ObjMove_AddPatternB2(obj, 0, NO_CHANGE, NO_CHANGE, 0, 0.025, 3, 3);
                	ObjMove_AddPatternB2(obj2, 0, NO_CHANGE, NO_CHANGE, 0, 0.025, 3, 3);
					angle3+=360/5;
					}
				if(type==2){
					ObjMove_AddPatternB2(obj, 0, NO_CHANGE, NO_CHANGE, 0, -0.04, 3, -2);
                	ObjMove_AddPatternB2(obj2, 0, NO_CHANGE, NO_CHANGE, 0, -0.04, 3, -2);
					angle3+=360/2;
				}
					ObjShot_SetAutoDelete(obj, false);
					ObjShot_SetAutoDelete(obj2,false);
					deleteshot2(obj, 500);
					deleteshot2(obj2,500);
				}
            }
            if(length < 500) {length+=10;}
            ObjLaser_SetLength(pointer, length);
		    if(type==1){
				angle++;
		    	angle2-=3;
				if(angle>= 360){angle=0;}
			}
		    if(type==2){
				angle-=0.5;
		    	angle2-=3;
				if(angle<= -180){angle=180;}
				}
		    angle3=0;
            ObjStLaser_SetAngle(pointer,angle);
            yield;
        }
		let length2 = length;
		loop(50){
		    if(type==1){
				angle++;
		    	angle2-=3;
				if(angle>= 360){angle=0;}
			}
		    if(type==2){
				angle-=0.5;
		    	angle2-=3;
				if(angle<= -180){angle=180;}
				}
            	if(length > 0) {length-=10;}
            	if(length < 0) {length = 0;}
            	ObjMove_SetX(pointer,ex+40*sin(angle+90));
            	ObjMove_SetY(pointer,ey-30*cos(angle+90));
            	ObjStLaser_SetAngle(pointer,angle);
				ObjLaser_SetLength(pointer, length);
				yield;
			}
		ObjShot_FadeDelete(pointer);
    }

    task laser2(ang,type){
        wait(100);
			PlaySound(PowerUp);
			loop(30){TChargeEffect(ex,ey,1);yield;}
        wait(30);
				PlaySound(Laser);
		let length1 = 0;
		let angle = ang;
		let angle2 = 0;
        let pointer = [];
		while(angle2<360){
			let obj = CreateStraightLaserA1(ex+30*sin(angle+angle2),ey-30*cos(angle+angle2),angle+angle2+90,length1,30,400,31,0);
			angle2 += 360/2;
        	pointer = pointer~[obj];
			}
			angle2 = 0;
        loop(360){
			ascent(i in 0..length(pointer)){
				CreateStraightLaserA1(ex+30*sin(angle+angle2),ey-30*cos(angle+angle2),angle+angle2-90,length1,10,  0,31,0);
				ObjMove_SetDestAtWeight(pointer[i],ex+30*sin(angle+angle2),ey-30*cos(angle+angle2),5,7.5);
            	ObjLaser_SetLength(pointer[i], length1);
            	ObjStLaser_SetAngle(pointer[i],angle+angle2-90);
			angle2 += 360/2;
			}
			angle2 = 0;
            if(length1 < 500) {length1+=2;}
				 if(type==1){angle+=0.7;}
				 if(type==2){angle-=0.7;}
				if(angle>= 360){angle=0;}
				yield;
        }
		let length2 = length1;
		TokiAttack;
		loop(50){
			ascent(i in 0..length(pointer)){
				CreateStraightLaserA1(ex+30*sin(angle+angle2),ey-30*cos(angle+angle2),angle+angle2-90,length1,10,  0,31,0);
				ObjShot_SetGraphic(pointer[i], 17); 
				ObjShot_SetIntersectionEnable(pointer[i], false);
				ObjMove_SetDestAtWeight(pointer[i],ex+30*sin(angle+angle2),ey-30*cos(angle+angle2),5,7.5);
            	ObjLaser_SetLength(pointer[i], length1);
            	ObjStLaser_SetAngle(pointer[i],angle+angle2-90);
			angle2 += 360/2;
			}
			angle2 = 0;
				 if(type==1){angle+=1.3;}
				 if(type==2){angle-=1.3;}
				if(angle>= 360){angle=0;}
            	if(length1 > 0) {length1-=10;}
            	if(length1 < 0) {length1 = 0;}
				yield;
			}
		if(type==1){laser2(rand(0,180),2);}
		if(type==2){laser2(rand(0,180),1);}
		ascent(i in 0..length(pointer)){
			Obj_Delete(pointer[i]);
		}
    }

	task deleteshot2(obj2,timer){
		wait(timer);
		ObjShot_FadeDelete(obj2);
	}
	
	task TokiAttack{
		ObjMove_SetSpeed(Toki,0);
		if(TokiAngle==0){ObjMove_SetPosition(Toki,  GetClipMinX-50,GetPlayerY);}
		if(TokiAngle==90){ObjMove_SetPosition(Toki, GetPlayerX,GetClipMinY-50);}
		if(TokiAngle==180){ObjMove_SetPosition(Toki,GetClipMaxX+50,GetPlayerY);}
		if(TokiAngle==270){ObjMove_SetPosition(Toki,GetPlayerX,GetClipMaxY+50);}
		TokiLaser;
		wait(60);
			PlaySound(Attack1);
		loop(10){TExplodeEffect(ObjMove_GetX(Toki),ObjMove_GetY(Toki),2);}
		ObjMove_SetAngle(Toki,  TokiAngle);
		ObjMove_SetSpeed(Toki,10);
		ObjMove_SetAcceleration(Toki,-0.08);
		TokiAngle+=90;
		if(TokiAngle==360){TokiAngle=0;}
	}

	task TokiLaser{
		let C = 0;
		let angle = 0;
		let angle2= TokiAngle;
		let angle3= TokiAngle;
		loop(60){
			while(angle<360){
				CreateStraightLaserA1(ObjMove_GetX(Toki)+C*sin(angle+angle3+90),ObjMove_GetY(Toki)-C*cos(angle+angle3+90),angle2,GetClipMaxY+200,6,0,30,0);
				angle+= 360/2;
			}
			C+=1;
			angle = 0;
			angle3+= 6;
			yield;
		}
		loop(75){
			while(angle<360){
				let obj = CreateShotA1(ObjMove_GetX(Toki)+20*sin(angle+angle3+90),ObjMove_GetY(Toki)-20*cos(angle+angle3+90), 1, -angle+angle3+180, 289, 6);
				deleteshot2(obj,30);
				ObjShot_SetSpellResist(obj,true);
				angle+= 360/7;
			}
			angle = 0;
			angle3+= 1.618*3;
			wait(1);
		}
	}

	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		loop(10){TExplodeEffect(ex,ey,1);}
		loop(10){TExplodeEffect(ObjMove_GetX(Toki),ObjMove_GetY(Toki),2);}
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}