let attackpose = false;
let heartEyes = false;
let InHand = false;


	let imgFam= CSD ~ "./System/Img/SakuraMiko.png";
	LoadTexture(imgFam);

task renderBoss(stage){
	let Z=0;
	let Y=0;
	let imgBoss;
		imgBoss = CSD ~ "./System/Img/Aiiko_Chibi.png";
		
	ObjPrim_SetTexture(objEnemy, imgBoss);
	ObjSprite2D_SetSourceRect(objEnemy,0,0,1600,1200);
	ObjSprite2D_SetDestCenter(objEnemy);
	ObjRender_SetScaleXYZ(objEnemy,0.1,0.1,0);

	callbackboss(objEnemy);
	
	while(!Obj_IsDeleted(objEnemy)) {
		if(InHand==false){
			ObjRender_SetScaleXYZ(objEnemy,0.1+0.04*sin(Z),0.1+0.03*cos(Z),0);
			ObjRender_SetAngleXYZ(objEnemy,0,0,20*cos(Z/2));
		}
			
		if(InHand){
			imgBoss = CSD ~ "./System/Img/Aiiko_Hand.png";
			ObjPrim_SetTexture(objEnemy, imgBoss);
			ObjRender_SetScaleXYZ(objEnemy,0.15+0.02*cos(Z),0.15+0.02*sin(Z),0);
			ObjSprite2D_SetSourceRect(objEnemy,Y,0,1600+Y,1200);
			ObjRender_SetAngleXYZ(objEnemy,0,0,0);
			Y=rand(-20,20);
		}

		Z+=2.5;
		yield;
	}
}

task AttackOn{
	attackpose = true;
}

task AttackOff{
	attackpose = false;
}

task HornyOn{
	heartEyes = true;
}

task HornyOff{
	heartEyes = false;
}

task callbackboss(user){
	let objMarker;
	let Alpha_BossMark = 255;
	let bossX = ObjMove_GetX(user);
	
	let imgMarker = CSD~"./System/Img/EnemyMarker.png";
	objMarker = CreateEffectObject(bossX+42*(4/5),GetStgFrameHeight+32,imgMarker,"ALPHA",0,0,42,16);
	EnemyMarker(user);
	
	task EnemyMarker(boss){
		while(!Obj_IsDeleted(boss)){

			bossX = ObjMove_GetX(user);
			ObjRender_SetPosition(objMarker,bossX+42*(4/5),GetStgFrameHeight+32*(4/5),0);
			Obj_SetRenderPriorityI(objMarker,100);
			if(ObjMove_GetX(boss) > GetClipMaxX || ObjMove_GetX(boss)<GetClipMinX){
				ObjRender_SetAlpha(objMarker,Alpha_BossMark);
				if(Alpha_BossMark >  0){Alpha_BossMark-= 255/10} 
			}
			if(ObjMove_GetX(boss) < GetClipMaxX && ObjMove_GetX(boss) > GetClipMinX){
				ObjRender_SetAlpha(objMarker,Alpha_BossMark);
				if(Alpha_BossMark < 255){Alpha_BossMark+= 255/10} 
			}
			yield;
		}
		Obj_Delete(objMarker);
	}
}

function CreateEffectObject(px,py,img,blendtype,left,top,right,bottom){
	let obj=ObjPrim_Create(OBJ_SPRITE_2D);
	LoadTexture(img);
	ObjPrim_SetTexture(obj,img);
	ObjSprite2D_SetSourceRect(obj,left,top,right,bottom);
	ObjSprite2D_SetDestCenter(obj);
	if(blendtype=="ALPHA"){
	ObjRender_SetBlendType(obj,BLEND_ALPHA);
	}
	if(blendtype=="RGB"){
	ObjRender_SetBlendType(obj,BLEND_ADD_RGB);
	}
	if(blendtype=="ARGB"){
	ObjRender_SetBlendType(obj,BLEND_ADD_ARGB);
	}
	ObjRender_SetPosition(obj,px,py,0);
	ObjMove_SetPosition(obj,px,py,);
	SetAutoDeleteObject(true);
	return obj;
}

function DrawAiiko(x,y,let clipDeath){ //Draws Mikos uwu
	let AnimFrame = 0;
	let Alpha_aiiko = 0;
	let S = 0.1;
	let pos;
	let obj=ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(obj);
	let shift=1;
	ObjRender_SetAlpha(obj,255);
	ObjEnemy_SetLife(obj,9999);
	ObjRender_SetPosition(obj,x,y,0);
	let alpha=255;
	let alpha_f= 0;
	TPos;
	renderBoss;
	return obj;
	task TPos{
		let DELETE_TYPE=2;
		while(!Obj_IsDeleted(objEnemy)&&ObjEnemy_GetInfo(obj,INFO_LIFE)>0){
			ObjMove_SetPosition(obj,ObjMove_GetX(obj),ObjMove_GetY(obj));
					//ObjEnemy_SetIntersectionCircleToShot(obj,ObjMove_GetX(obj),ObjMove_GetY(obj),14);
					//DeleteShotInCircle(TYPE_ALL,TYPE_FADE ,ObjMove_GetX(obj),ObjMove_GetY(obj),50);
			if(clipDeath==true){
				if(ObjMove_GetX(obj)<=0||ObjMove_GetX(obj)>=GetStgFrameWidth||ObjMove_GetY(obj)<=0||ObjMove_GetY(obj)>=GetStgFrameHeight){
					DELETE_TYPE=1;
					break;
				}
			}
			yield;
		}
		if(DELETE_TYPE!=1){
			TExplosionA(ObjMove_GetX(obj),ObjMove_GetY(obj),22.5,0.3);
		}
		Obj_Delete(obj);
	}
	task renderBoss{
	let Z=0;
	let Y=0;
	let imgBoss = CSD ~ "./System/Img/Toki.png";
		
	ObjPrim_SetTexture(obj, imgBoss);
	ObjSprite2D_SetSourceRect(obj,0,0,1300,1700);
	ObjSprite2D_SetDestCenter(obj);
	ObjRender_SetScaleXYZ(obj,0.1,0.1,0);

	callbackboss(obj);
	
		while(!Obj_IsDeleted(obj)) {
			
			if(InHand==false){
				ObjRender_SetScaleXYZ(obj,0.06+0.01*sin(Z),0.06+0.01*cos(Z),0);
				ObjRender_SetAngleXYZ(obj,0,0,20*cos(Z/2));
				ObjSprite2D_SetSourceRect(obj,2600,0,3900,2000);
			}

			if(InHand){
				imgBoss = CSD ~ "./System/Img/Toki_Hand.png";
				ObjPrim_SetTexture(obj, imgBoss);
				ObjRender_SetScaleXYZ(obj,0.165+0.02*sin(Z),0.105+0.02*cos(Z),0);
				ObjSprite2D_SetSourceRect(obj,Y,0,1600+Y,1200);
				ObjRender_SetAngleXYZ(obj,0,0,0);
				Y=rand(-20,20);
			}
			
			Z+=2.5;
			yield;
		}
	}
}