#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_NS2"]
	#Text["Aiiko sacudiendo las alas"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	
	@Initialize{
		SetAutoDeleteObject(true);
		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetDestAtFrame(objEnemy,GetClipMaxX/2,GetClipMaxY/4,30);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(6000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(120);
		}
	}
	
	task movement{
			wait(180);
		let X = 0;
		let Y = 0;
		Fire;
		Fire3;
		
		loop{
		X = rand(GetPlayerX-50,GetPlayerX+50);
		Y = rand(GetClipMaxY/4,GetClipMaxY/8);
		if(X<GetClipMaxX/5){X =GetClipMaxX/5;}
		if(X>(GetClipMaxX/5)*4){X =(GetClipMaxX/5)*4;}
			ObjMove_SetDestAtWeight(objEnemy, X, Y, 15,6);
			wait(180);
			yield;
		}
	}
	
	task Fire{
		wait(24);
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = 0;
		let A=0;
		let color = 38;
			PlaySound(Attack5);
		loop(2){
			loop(8){
				loop(8){
					let obj = CreateShotA2(X,Y,7+A,angle+angle2,-0.5,2+A,color,6);
					ObjMove_AddPatternA2(obj, 30, NO_CHANGE, angle+angle2, NO_CHANGE, -1, 2+A);
					ObjMove_AddPatternA2(obj, 120+A*60, NO_CHANGE, NO_CHANGE, NO_CHANGE, 0, 2+A);
					angle2+= 1.618;
					A+=0.1;
				}
			A=0;
			angle -= 45;
			angle2 = 0;
			}
			color = 84;
			wait(5);
			yield;
		}
		Fire2;
	}
	
	task Fire2{
		wait(24);
		let X = ex+rand(50,-50);
		let Y = ey+rand(25,-25);;
		let angle = rand(0,360);
		let angle2 = 0;
		let A=0;
		let color = 39;
			PlaySound(Attack5);
		loop(2){
			loop(8){
				loop(8){
					let obj = CreateShotA2(X,Y,7+A,angle+angle2,-0.5,2+A,color,6);
					ObjMove_AddPatternA2(obj, 30, NO_CHANGE, angle+angle2, NO_CHANGE, 1, 2+A);
					ObjMove_AddPatternA2(obj, 120+A*60, NO_CHANGE, NO_CHANGE, NO_CHANGE, 0, 2+A);
					angle2-= 1.618;
					A+=0.1;
				}
				A=0;
				angle += 45;
				angle2 = 0;
				}
			color = 83;
			wait(5);
			yield;
			}
		Fire;
	}

	task Fire3{
		wait(90);
		loop{
		loop(3){TChargeEffect(ex, ey,1);}
		wait(30);
			PlaySound(Attack3);
			CreateShotA2(ex, ey, 10, GetAngleToPlayer(objEnemy), -0.5, 3, 276, 12);

			let obj=CreateShotA2(ex, ey, 10, GetAngleToPlayer(objEnemy)+45, -0.5, 3, 273, 6);
			ObjMove_AddPatternA2(obj, 6, NO_CHANGE, NO_CHANGE, NO_CHANGE, 1, 2);
			ObjMove_AddPatternA2(obj, 120, NO_CHANGE, NO_CHANGE, NO_CHANGE, -0, 2);

			let obj2=CreateShotA2(ex, ey, 10, GetAngleToPlayer(objEnemy)-45, -0.5, 3, 273, 6);
			ObjMove_AddPatternA2(obj2, 6, NO_CHANGE, NO_CHANGE, NO_CHANGE, -1, 2);
			ObjMove_AddPatternA2(obj2, 120, NO_CHANGE, NO_CHANGE, NO_CHANGE, 0, 2);
			wait(90);
			yield;
		}
	}
	
	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}