#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_S2"]
	#Text["The Naked Sun [r]A spell card full of drones chargin at you"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	
	@Initialize{
		SetAutoDeleteObject(true);
	
		let objScene = GetEnemyBossSceneObjectID();
		ObjEnemyBossScene_StartSpell(objScene);

		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetDestAtWeight(objEnemy,190,80,8,5);
		Fire1;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		Cutin(objEnemy,"The Naked Sun",1);
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(6000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(60);
		}
		case(EV_REQUEST_SPELL_SCORE) {
			SetScriptResult(200000);
		}
	}
	
	task Fire1{
		let B = rand(150,210);
		let C = 0;
		let angle= 0;
		wait(30);
		loop{
			loop(5){
				loop(3){TChargeEffect(ex, ey,1);}
				wait(30);
				C = GetAngleToPlayer(objEnemy);
			PlaySound(Twinkle);
				let obj = CreateShotA2(ex, ey, 10, C, -0.5, 0, 279, 30);
				BulletMove(obj);
				ObjShot_SetAutoDelete(obj, false);
				ObjShot_SetSpellResist(obj,true);
				AttackOff;
				wait(60);
				ObjMove_SetDestAtWeight(objEnemy,rand(GetClipMinX+100,GetClipMaxX-100),rand(20,160),15,6);
				wait(90);
			}
			wait(90);
			C = GetAngleToPlayer(objEnemy);
			loop(9){TChargeEffect(ex, ey,1);}
			wait(30);
			loop(3){
			PlaySound(Twinkle);
				let obj = CreateShotA2(ex, ey, 10, C, -0.5, 0, 279, 30);
				BulletMove(obj);
				ObjShot_SetAutoDelete(obj, false);
				ObjShot_SetSpellResist(obj,true);
				AttackOff;
				wait(12);
				C += 360/3;
			}
		wait(180);
		yield;
		}
	}
	
	task BulletMove(obj){
		let xaccel;
		let yaccel;
		let maxxspeed;
		let maxyspeed;

		wait(60);
		loop(9){TExplodeEffect(ObjMove_GetX(obj), ObjMove_GetY(obj),1);}
		FireBullet(obj);
		trail(obj);
        laser(obj);
		
		if(!Obj_IsDeleted(obj)){
        
		loop(300){
			if(ObjMove_GetX(obj)<=GetPlayerX) { xaccel =  0.02; maxxspeed =  2; }
			if(ObjMove_GetX(obj)> GetPlayerX) { xaccel = -0.02; maxxspeed = -2; }
			if(ObjMove_GetY(obj)<=GetPlayerY) { yaccel =  0.02; maxyspeed =  2; }
			if(ObjMove_GetY(obj)> GetPlayerY) { yaccel = -0.02; maxyspeed = -2; }

			ObjMove_AddPatternB3(obj, 0, NO_CHANGE, NO_CHANGE, xaccel, yaccel, maxxspeed, maxyspeed,276);
			yield;
		}
		ObjShot_SetGraphic(obj,273);
		ObjShot_SetAutoDelete(obj, true);
		ObjMove_AddPatternA2(obj, 0, NO_CHANGE, NO_CHANGE, 0.02, 0, 2);
		}
		
	}

    task laser(obj){
        let color = 63;
		let length = GetGapLength(ObjMove_GetX(obj),ObjMove_GetY(obj),GetPlayerX,GetPlayerY);
		let angle = GetAngleToPlayer(obj);
        let pointer = CreateStraightLaserA1(ObjMove_GetX(obj)+25*sin(angle),ObjMove_GetY(obj)-25*cos(angle),GetAngleToPlayer(obj),length-30,5,1000,color,0);
					ObjShot_SetIntersectionEnable(pointer, false);
        loop(300){
            ObjMove_SetX(pointer,ObjMove_GetX(obj)+20*sin(angle+90));
            ObjMove_SetY(pointer,ObjMove_GetY(obj)-20*cos(angle+90));
            length = GetGapLength(ObjMove_GetX(obj),ObjMove_GetY(obj),GetPlayerX,GetPlayerY);
            ObjLaser_SetLength(pointer, length-50);
		    angle = GetAngleToPlayer(obj);
            ObjStLaser_SetAngle(pointer,angle);
            ObjShot_SetGraphic(pointer,color);
            color++;
            if(color>=78){color = 64;}
            yield;
        }
        Obj_Delete(pointer);
    }

	task FireBullet(obj){
		let B = ObjMove_GetAngle(obj);
		let angle= 0;
		let color= 186;
		let X;
		loop(5){
				if(!Obj_IsDeleted(obj)){
			PlaySound(Twinkle3);
				while (angle<360){
					//PlaySound(Attack3SFX);
					CreateShotA2(ObjMove_GetX(obj)+25*sin(angle+B),ObjMove_GetY(obj)-25*cos(angle+B),0,angle+B-90,0.01,1.5,color,12);
					let obj2 =CreateShotA2(ObjMove_GetX(obj)+25*sin(angle+B),ObjMove_GetY(obj)-25*cos(angle+B),0.5,angle+B+45,0.01,1.5,color,12);
					let obj3 =CreateShotA2(ObjMove_GetX(obj)+25*sin(angle+B),ObjMove_GetY(obj)-25*cos(angle+B),0.5,angle+B+90,0.01,1.5,color,12);
					deleteshot2(obj2);
					deleteshot2(obj3);
					angle+=360/28;
					color++;
					if(color>=193){color= 186;}
					}}
				B = ObjMove_GetAngle(obj);
				angle=0;
			wait(rand(60,120));
			yield;
		}
	}
	
	task trail(obj){
		loop{
			if(!Obj_IsDeleted(obj)){
				let obj2=CreateShotA2(ObjMove_GetX(obj)+rand(-10,10),ObjMove_GetY(obj)+rand(-10,10),rand(0.1,0.5),rand(0,360),-0.01,0,189,24);
				deleteshot(obj2);
			}
			yield;
		}
	}
	
	task deleteshot(obj2){
		let alpha = 255;
		wait(rand(18,23));
		Obj_Delete(obj2);
	}
	
	task deleteshot2(obj2){
		wait(18);
		ObjShot_FadeDelete(obj2);
	}

	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		loop(5){TExplodeEffect(ex,ey,1);}
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}