#TouhouDanmakufu[Single]
	#ScriptVersion[3]
	#Title["Aiiko_S4"]
	#Text["Roko's harpy [r] A spell Card full or dispair and nihilism"]
	#Player["./System/Murloc/Reimu/Reimu.txt"]
	#include"./Index.txt"

	let objEnemy;
		let ex = 0;
		let ey = 0;
	let orbs=[];
	let B = rand(0,360);
	
	@Initialize{
		SetAutoDeleteObject(true);
	
		let objScene = GetEnemyBossSceneObjectID();
		ObjEnemyBossScene_StartSpell(objScene);

		objEnemy = ObjEnemy_Create(OBJ_ENEMY_BOSS);
		ObjEnemy_Regist(objEnemy);
		ObjMove_SetDestAtWeight(objEnemy,190,80,8,5);
		movement;
		renderBoss(1);
		TEnd;

		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets upon appearance	
	}

	@MainLoop{
		ex = ObjMove_GetX(objEnemy);
		ey = ObjMove_GetY(objEnemy);
		ObjEnemy_SetIntersectionCircleToShot(objEnemy, ex, ey, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(objEnemy, ex, ey, 24);

		yield;
	}

	@Event{
		alternative(GetEventType())
		case(EV_REQUEST_LIFE)
		{
			SetScriptResult(6000);
		}
		case(EV_REQUEST_TIMER)
		{
			SetScriptResult(120);
		}
		case(EV_REQUEST_SPELL_SCORE) {
			SetScriptResult(200000);
		}
	}

task movement{
		Cutin(objEnemy,"Roko's harpy",1);
		wait(60);
		Fire1;
		Fire2;
	loop{
		ObjMove_SetDestAtSpeed(objEnemy,rand(GetClipMinX+100,GetClipMaxX-100),rand(50,150),1);
		wait(120);
		yield;
	}
}
	
	task Fire1{
		wait(30);
		let obj;
		let increasing = true;
		let angle= 0;
		loop{
		loop(5){
			loop(6){TChargeEffect(ex,ey,1);}
			wait(30);
			PlaySound(Twinkle);
			while (angle<360){
				obj=CreateShotA2(ex+30*sin(angle+B),ey-30*cos(angle+B),5,angle+B-90,-0.5,0.3,69,24);
				ObjShot_SetSpellResist(obj,true);
				ObjShot_SetAutoDelete (obj, false);
				orbs=orbs~[obj];
				circle(obj);
				angle+=360/36;
			}
			B = rand(0,360);
			angle=0;
			wait(120);
			ring;
			angle=0;
			wait(60);
		}
			wait(60);
		loop(3){
			loop(6){TChargeEffect(ex,ey,1);}
			wait(30);
			PlaySound(Twinkle);
			while (angle<360){
				obj=CreateShotA2(ex+10*sin(angle+B),ey-10*cos(angle+B),5,angle+B-90,-0.5,0.3,69,24);
				ObjShot_SetSpellResist(obj,true);
				ObjShot_SetAutoDelete (obj, false);
				orbs=orbs~[obj];
				circle(obj);
				angle+=360/36;
			}
			B = rand(0,360);
			angle=0;
			wait(90);
			ring;
			angle=0;
		}
			wait(120);
		yield;
		}
	}
	
	task ring{
		let obj2;
		let obj3;
		let X= GetPlayerX;
		let Y= GetPlayerY;
		let angle= 0;
		PlaySound(PowerUp);

		while (angle<360){
			obj2=CreateShotA2(X+60*sin(angle+GetAngleToPlayer(objEnemy)+90), Y-60*cos(angle+GetAngleToPlayer(objEnemy)+90), 0, angle+GetAngleToPlayer(objEnemy)+90,0,0,69,24);
			obj3=CreateShotA2(X+60*sin(-angle+GetAngleToPlayer(objEnemy)+90),Y-60*cos(-angle+GetAngleToPlayer(objEnemy)+90),0,-angle+GetAngleToPlayer(objEnemy)+90,0,0,69,24);
			angle+=10;
			ObjShot_FadeDelete(obj2);
			ObjShot_FadeDelete(obj3);
			yield;
		}
	}
	
	task circle(obj){
		wait(120);
		let ang = ObjMove_GetAngle(obj);
		let X = GetPlayerX;
		let Y = GetPlayerY;
		wait(rand(0,60));
		let ang2 = GetGapAngle(ObjMove_GetX(obj),ObjMove_GetY(obj),X,Y);
		let angle= 0;
		ObjMove_SetDestAtWeight(obj,X+60*sin(angle+B),Y-60*cos(angle+B),15,3);
		CreateStraightLaserA1(ObjMove_GetX(obj)+0*sin(angle+B), ObjMove_GetY(obj), ang2, GetGapLength(ObjMove_GetX(obj),ObjMove_GetY(obj),X,Y),3,0,30,0);
		B+=360/18;
		wait(120);
		//ObjMove_SetAngle(obj,atan2(Y - ObjMove_GetY(obj), X - ObjMove_GetX(obj))+90);
		//ObjMove_SetSpeed(obj,0.1);
		wait(60);
			PlaySound(Twinkle3);
		CreateShotA2(ObjMove_GetX(obj),ObjMove_GetY(obj),0.5, atan2(Y - ObjMove_GetY(obj), X - ObjMove_GetX(obj))+30,0.01,5,39,12);
		CreateShotA2(ObjMove_GetX(obj),ObjMove_GetY(obj),0.5, atan2(Y - ObjMove_GetY(obj), X - ObjMove_GetX(obj))-30,0.01,5,39,12);
		let pointer = CreateStraightLaserA1(ObjMove_GetX(obj), ObjMove_GetY(obj), atan2(Y - ObjMove_GetY(obj), X - ObjMove_GetX(obj))+30,700,5,12,39,0);
		let pointer2= CreateStraightLaserA1(ObjMove_GetX(obj), ObjMove_GetY(obj), atan2(Y - ObjMove_GetY(obj), X - ObjMove_GetX(obj))-30,700,5,12,39,0);
					ObjShot_SetIntersectionEnable(pointer, false);
					ObjShot_SetIntersectionEnable(pointer2, false);
		ObjShot_FadeDelete(obj);
	}
	
	task Fire2{
		wait(60);
		let ang = rand(0,360);
		loop{
			PlaySound(Twinkle2);
			ShootShape(ex,ey, 3, ang, 3, 10, 85, 30);
			ShootShape(ex,ey, 2, ang, 3, 20, 84, 18);
			wait(30);
			PlaySound(Twinkle2);
			ShootShape(ex,ey, 3, ang-180, 3, 10, 85, 30);
			ShootShape(ex,ey, 2, ang-180, 3, 20, 84, 18);
			wait(rand(180,240));
			ang = rand(0,360);
		yield;
		}
	}

	task TEnd{
		while(ObjEnemy_GetInfo(objEnemy, INFO_LIFE) > 0)
		{
			yield;
		}

		let ex = ObjMove_GetX(objEnemy);
		let ey = ObjMove_GetY(objEnemy);
		TExplosionA(ex, ey, 10, 0.6);
		loop(5){TExplodeEffect(ex,ey,1);}
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);//Removes all enemy bullets	

		//When making plural scripts,
		//Deleting the enemy allows the plural script to proceed on to the next script.
		//Do not forget to delete the enemy.
		Obj_Delete(objEnemy);

		loop(30){yield;}

		//Please close the script at the end
		CloseScript(GetOwnScriptID());
	}